<template>
  <div>
    <ModuleHeroHeader
      ref="heroheader"
      class="heroheader"
      :items="{ left: slidesLeft, right: slidesRight }"
    />
    <div class="anchor-menu">
      <button
        v-if="show.description"
        v-scroll-to="`#infos`"
        class="infos-btn"
        :class="[dates.length ? '' : 'col-span-2']"
      >
        {{ $tr('button-info-show') }}
      </button>
      <button
        v-if="dates.length && !noUpcomingDates"
        v-scroll-to="{ el: '#dates', offset: -200 }"
        class="dates-btn"
      >
        {{ $tr('button-dates-show') }}
      </button>
      <div class="icon">
        <UiCoreVIcon name="south" />
      </div>
    </div>

    <div class="page">
      <div class="gallery">
        <NuxtImg
          v-for="(item, index) in show.images"
          :key="`image-${index}`"
          :src="`${$config.apiUrl}/assets/${item.directus_files_id.id}/${item.directus_files_id.title}`"
          :width="900"
          :height="600"
          responsive
          loading="lazy"
          class="image"
          :is-static="true"
          format="webp"
          :alt="
            item.directus_files_id.description || item.directus_files_id.title
          "
        />
      </div>
      <div id="infos" class="infos">
        <div v-if="show" class="description" v-html="show.description" />

        <div v-if="show && show.distribution" class="distribution">
          <ModuleBackgroundedText
            color="#FFF"
            :bgcolor="show.color || 'darkgrey'"
            :text="`<h2>${$tr('distribution')}</h2> ${show.distribution}`"
          />
        </div>
        <div v-if="show && show.files.length" class="files">
          <ModuleBackgroundedText
            color="#FFF"
            :bgcolor="show.color || 'darkgrey'"
          >
            <div class="inner">
              <h2>{{ $tr('downloads') }} :</h2>
              <ul>
                <li v-for="file in show.files" :key="file.filename_download">
                  <a
                    :href="`${$config.apiUrl}/assets/${file.directus_files_id.id}?download`"
                    :download="file.filename_download"
                  >
                    {{ file.directus_files_id.title }}
                  </a>
                </li>
              </ul>
            </div>
          </ModuleBackgroundedText>
        </div>
        <div
          v-if="show && dates.length && !noUpcomingDates"
          id="dates"
          class="dates"
        >
          <div class="dates__bg" :style="{ fill: show.color || 'darkgrey' }">
            <PolygonShapeAlt />
          </div>
          <div class="dates__content">
            <h2>{{ $tr('upcoming_dates') }}</h2>

            <ModuleDateList
              v-if="dates"
              :dates="dates"
              :limit="5"
              upcoming
              @noUpcomingDates="noUpcomingDates = true"
            />

            <nuxt-link :to="`/dates?id=${show.id}`" class="all-dates">
              Voir toutes les dates
              <UiCoreVIcon name="east" class="icon-close" />
            </nuxt-link>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  async asyncData({ params, $api }) {
    const show = await $api.show.getShow(params.slug)

    const slidesLeft = show.data[0].slides_left

    const slidesRight = show.data[0].slides_right

    const dates = await $api.dates.datesByShow(params.slug)

    return {
      show: show.data[0],
      slidesLeft,
      slidesRight,
      dates: dates.data,
    }
  },
  data() {
    return {
      show: null,
      dates: null,
      slidesLeft: null,
      slidesRight: null,
      noUpcomingDates: false,
    }
  },
  head() {
    return {
      title: `Oh! Oui... ${this.show.name}`,
    }
  },
  computed: {
    dateslink() {
      return this.dates.length > 5 ? `/dates?id=${this.show.id}` : `/dates`
    },
  },
  mounted() {
    this.$store.commit('heroheader/setItems', {
      left: this.slidesLeft,
      right: this.slidesRight,
    })
    const t = this
    // fire event with page title as param
    setTimeout(() => {
      t.$nuxt.$emit('pageloaded', {
        title: this.show.name,
      })
    }, 500)
  },
}
</script>

<style lang="scss">
.page {
  @apply min-h-screen h-full w-screen flex-col-reverse flex;

  @screen md {
    @apply grid grid-cols-2 gap-10;
  }

  background: #fcfcfc;

  .gallery {
    @apply mt-24;

    @screen lg {
      @apply mt-0 flex flex-col items-center;
    }
  }
  a {
    @apply underline;
  }
}

.files {
  @apply px-0 py-20  flex flex-col items-start max-w-xl self-start m-0 -mt-10;

  @screen xl {
    @apply px-16 py-16  self-end -mt-20 mr-10;
  }

  .inner {
    @apply pr-20;
    @apply py-12;
    @screen lg {
      @apply px-12 pt-12 pb-0;
    }
  }
  .backgrounded-text__bg {
    opacity: 0.9;
    transform: skew(-15deg, 2deg) !important;
  }
}

.infos {
  @apply px-8 py-8  flex flex-col items-start;

  @screen xl {
    @apply px-16 py-16;
  }

  > * {
    @apply max-w-xl;
  }

  h1 {
    @apply text-xl uppercase font-medium mb-8;
  }

  h2 {
    @apply text-xl uppercase font-medium mb-8;
  }

  .description {
    @apply z-10;

    iframe {
      @apply max-w-full mx-auto w-full;
    }
  }

  .dates {
    @apply mt-32 relative w-full flex-col;

    display: flex;

    &__bg {
      @apply absolute inset-0 flex-grow w-full -m-24;
      opacity: 0.6;

      svg {
        width: 200%;
        height: 120%;
        margin-top: -30%;
        margin-left: 0 !important;

        @screen md {
          width: 160%;
          height: 120%;
          margin-top: -15%;
        }
      }
    }
    &__content {
      @apply z-10 text-white;
    }
  }

  .distribution {
    @screen xl {
      @apply my-16;
    }
    p {
      @apply pt-4;
    }
    img {
      display: inline-block;
    }
    .backgrounded-text {
      @screen xxl {
        transform: translateX(0%);
      }
    }
    .backgrounded-text__bg {
      @apply -m-20 -mt-6 p-0;

      opacity: 0.9;

      @screen md {
        @apply -mt-4;
      }
      @screen xl {
        @apply -mt-28;
      }
    }
  }

  .dates {
    @apply mt-32 pb-36;

    @screen md {
      @apply pb-6;
    }

    &__bg {
      @apply -ml-64;

      @screen md {
        @apply -ml-64;
      }
      @screen xl {
        @apply -ml-64;
      }
      opacity: 0.9;

      svg {
        width: 200vw;
        @apply -ml-64;

        @screen md {
          @apply -ml-4 -mt-32;
          width: 100vw;
        }
        @screen lg {
          width: 180%;
        }
      }
    }
    ul {
      @apply mb-10;
    }
    .all-dates {
      @apply text-xl uppercase no-underline;
      //   --v-icon-size: 18px;
      .v-icon {
        margin-top: -2px;
        margin-left: 4px;
      }
    }
  }
}

.image {
  width: 70%;
  animation: 2s appear;
}

@for $i from 1 through 100 {
  .image:nth-child(#{$i}) {
    max-width: 95 - 2 * $i + vw;
    margin-top: 20 - $i * 10 + 20 * ($i - 1) + px;
    margin-left: 100 + $i * 10 + random(200) - 150 + px;
    transform: rotate(random(40) - 20 + deg);
    @screen lg {
      max-width: 35 - 2 * $i + vw;
      margin-top: 40 - $i * 10 + 10 * ($i - 1) + px;
    }
  }
}

@keyframes appear {
  0% {
    opacity: 0;
  }
  50% {
    opacity: 1;
  }
}
</style>
